//
// Created by lee on 2019/8/17.
//
#include "struct_wave.h"
#include <alsa/asoundlib.h>

int main(int argc, char* argv[]){
    int rc, err, dir;
    unsigned int val;
    snd_pcm_t *handle;
    snd_pcm_format_t pcm_fmt;
    snd_pcm_hw_params_t *params;

//    CWaveHeader wavheader, *cheader;
//    cheader = &wavheader;
//    string file1("/home/lee/CLionProjects/Asound/alsa/01_000038.wav");
//    ReadCWaveHeader(file1.c_str(), &wavheader);
//
//    if(cheader->BitsPerSample == 8){
//        pcm_fmt = SND_PCM_FORMAT_S8;
//    }else if(cheader->BitsPerSample == 16){
//        pcm_fmt = SND_PCM_FORMAT_S16_LE;
//    }else{
//        printf("uBitsPerSample not support!\n");
//        return -1;
//    }

    /* Open PCM device for playback. */
    rc = snd_pcm_open(&handle, "default",SND_PCM_STREAM_PLAYBACK, 0);
    if (rc < 0) {
        fprintf(stderr,"unable to open pcm device: %s\n",snd_strerror(rc));
        exit(1);
    }

/* Allocate a hardware parameters object. */
    //val = snd_pcm_hw_params_alloca(&params);
    snd_pcm_hw_params_malloc(&params);

/* Fill it in with default values. */
    snd_pcm_hw_params_any(handle, params);

/* Interleaved mode */
    snd_pcm_hw_params_set_access(handle, params,SND_PCM_ACCESS_RW_INTERLEAVED);

/* Signed 16-bit little-endian format */
    err =  snd_pcm_hw_params_set_format(handle, params,SND_PCM_FORMAT_S16_LE);

    if( err < 0){
        fprintf(stderr, "cannot allocate hardware parameter structure (%s)\n",snd_strerror(err));
        goto play_wav_out;
    }

/* 44100 bits/second sampling rate (CD quality) */
    val = 44100;
    snd_pcm_hw_params_set_rate_near(handle,params, &val, &dir);

/* Two channels (stereo) */
    snd_pcm_hw_params_set_channels(handle, params, 1);

/* Write the parameters to the driver */
    rc = snd_pcm_hw_params(handle, params);
    if (rc < 0) {
        fprintf(stderr,"unable to set hw parameters: %s\n",snd_strerror(rc));
        exit(1);
    }

    //snd_pcm_hw_params_set_p
    snd_pcm_hw_params_get_rate(params, (unsigned int*)&val, &dir);
    printf("get rate: %d\n",val);

    snd_pcm_hw_params_get_channels(params, (unsigned int*)&val);
    printf("get channles: %d\n",val);

    snd_pcm_hw_params_get_period_time(params, (unsigned int*)&val, &dir);
    printf("period time: %d\n", val);

    snd_pcm_hw_params_get_buffer_time(params, &val, &dir);
    printf("buffer time is %d\n", val);
    snd_pcm_hw_params_get_period_size(params, (snd_pcm_uframes_t*)&val, &dir);
    printf("period size: %d frames\n", val);

    snd_pcm_hw_params_get_buffer_size(params, (snd_pcm_uframes_t*)&val);
    printf("buffer size default: %d frames\n", val);

    snd_pcm_hw_params_get_periods(params, &val, &dir);
    printf("periods per buffer = %d frames\n", val);

    //snd_pcm_hw_params_get_buffer_size(hw_params, (snd_pcm_uframes_t*)&frames);
    snd_pcm_hw_params_free(params);

    snd_pcm_close(handle);


    return 0;
    play_wav_out:
        return -1;


}

